fl

{
i2c_utility
PropForth5.5

2014/01/04 22:56:06
}


\ Modified _eewrite ( c1 -- t/f ) write c1 to the eeprom, true if there was an error
\ Received acknowledge from i2c-device during scl is high
\ scl/sda use pull-up resistor at hi
\ clock:384kHz
lockdict create _eewrite forthentry
$C_a_lxasm w, h130  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2WyPj8 l, z1YVPQ0 l, z1rixng l, z1Sy\[d l, z1[ixnh l, z1Sy\[d l, z1Sy\[d l, z1bixnh l,
zfyPO1 l, z1Sy\[d l, z3[yPnK l, z1[ixng l, z1Sy\[d l, z1[ixnh l, z1Sy\[d l, z1YF\il l,
z1viPR6 l, z1Sy\[d l, z1bixnh l, z1Sy\[d l, z1Sy\[d l, z1bixng l, z1SV01X l, z2WiQCi l,
z3[yQCe l, z1SV000 l, zW0000 l, zG0000 l, zB l,
freedict


\ Modified _eeread ( t/f -- c1 ) flag should be true is this is the last read
\ scl/sda use pull-up resistor at hi
\ clock:384kHz
lockdict create _eeread forthentry
$C_a_lxasm w, h131  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2WiPZB l, z2WyPO0 l, z1[ixnh l, z2WyPj8 l, z1Sy\fe l, z1[ixni l, z1Sy\fe l, z1XF\ql l,
znyPO1 l, z1Sy\fe l, z1bixni l, z1Sy\fe l, z3[yPnN l, z1Sy\fe l, z26VPW0 l, z1rixnh l,
z1Sy\fe l, z1[ixni l, z1Sy\fe l, z1Sy\fe l, z1bixni l, z1bixnh l, z1Sy\fe l, z1SV01X l,
z2WiQCj l, z3[yQCf l, z1SV000 l, zW0000 l, zG0000 l, zB l,
freedict

: err_msg ." I2C error" ;
\ If error, print message
\ ( n1 -- )   n1:t/f
: err? if err_msg cr then ;

\ Start i2c-commnication 
\ ( -- )
: _eestart
_sdal _sdao    \ Set sda to lo 
_scll _sclo    \ Set scl to lo
;

\ Repeated Start
\ ( -- )
: Sr
_sdai               \ Release sda 
_scli	          \ Release scl 
\ begin d28 px? until \ wait until scl is hi
_sdao               \ Set sda to lo
_sclo               \ Set sda to lo
;

\ Stop i2c-commnication 
\ ( -- )
: _eestop
_scli     \ Release scl 
_sdai     \ Release sda
;

\ Write series data to register in i2c_device
\ ( n1..nn n2 n3 n4 -- n4..nn t/f )   n1..nn:data  n2:number  n3:register  n4:slave_address   t/f:true if there was an error
: i2c_wr_multi
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi) 
_eewrite                                \ ( n1..nn n2 n3 t/f )
\ Write register                   
swap _eewrite or                        \ ( n1..nn n2 t/f )
swap                                    \ ( n1..nn t/f n2 )
\ Read n2 byte
dup 1 >
if                                      \ ( n1..nn t/f n2 )                 
     0 do                               \ ( n1..nn t/f )
          swap _eewrite or              \ ( n1.. nn t/f ) 
     loop
else                                    \ ( n1 t/f n2 )     
     drop swap _eewrite or              \ ( t/f )
then               
\ Stop I2C
 _eestop 
;

\ Read sereis data from series register in i2c_device
\ ( n1 n2 n3 -- n4 . . nn t/f )  n1:number  n2:register  n3:slave_address  n4..nn:series data  t/f:true if there was an error
: i2c_rd_multi
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)  
tuck _eewrite                 \ ( n1 n3 n2 t/f )
\ Write register
swap _eewrite or              \ ( n1 n3 t/f )
swap                          \ ( n1 t/f n3 )
\ Repeated Start read_process
Sr
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
1 or 
_eewrite or                   \ ( n1 t/f )
\ Read (n1-1)bytes
>r                            \ Push flag  ( n1 )
dup 1 > 
if 
     1 - 0 do 
          0 _eeread           \ ( n4..nn-1 )
     loop
else
     drop
then
\ Read 1byte ,then set sda to Hi(NACK:master->slave)
-1 _eeread                    \ ( n4..nn )
r>                            \ Pop flag   ( n4..nn t/f )
\ Stop I2C
_eestop                                         
;


\ Print out connected i2c-devices slave-address
\ ( -- )
: i2c_detect
hex
\ Print lower
."      0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F" cr
0 0 
8 0 do
     \ Print 1-line
     dup .byte h3A emit space           
     d16 0 do
          \ Start I2C 
          _eestart
          \ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
          dup i + 1 lshift _eewrite 0=                      
          if                                 \ there is ACK 
               dup i + dup .byte             \ Get slave-addres
               0 > if swap 1+ swap then      \ Count device's number (eliminate '00')
          else 
               ." --" 
          then 
          space 
          \ Stop I2C
          _eestop                                       
     loop
     cr
     \ next line
     d16 +                                                      
loop
drop
decimal
." i2c_device:" . cr  cr
;







\ ------------------------------------------------------------------------------------------
\  Modified _eewrite
\ ------------------------------------------------------------------------------------------

\ Modified _eewrite ( c1 -- t/f ) write c1 to the eeprom, true if there was an error
\ Received acknowledge from i2c-device during scl is high
\ scl/sda use pull-up resistor at hi
\ clock:384kHz
{
build_BootOpt :rasm

		mov     $C_treg3 , # h8
          \ Set data-bit to sda
__x0B
		test    $C_stTOS , # h80	wz
		muxz    dira , __x02sda
		jmpret  __x0Fdelayret , # __x0Edelay/2
		
          \ Set scl to Hi
		andn    dira , __x03scl
		jmpret  __x0Fdelayret , # __x0Edelay/2
		jmpret  __x0Fdelayret , # __x0Edelay/2

          \ Set scl to lo
		or      dira , __x03scl
		
		\ Shift data-bit
		shl     $C_stTOS , # 1

		jmpret  __x0Fdelayret , # __x0Edelay/2

          \ Finish 8bit?
		djnz    $C_treg3 , # __x0B

          \ Set sda to input(floating)
		andn    dira , __x02sda
		jmpret  __x0Fdelayret , # __x0Edelay/2

          \ Set scl to Hi
		andn    dira , __x03scl

		jmpret  __x0Fdelayret , # __x0Edelay/2
		\ Input sda from slave   Read ACK
		test    __x02sda , ina	wz
		muxnz   $C_stTOS , $C_fLongMask
		jmpret  __x0Fdelayret , # __x0Edelay/2

          \ Set scl to lo
		or      dira , __x03scl

		jmpret  __x0Fdelayret , # __x0Edelay/2
		jmpret  __x0Fdelayret , # __x0Edelay/2
		
		\ Set sda to lo and output
		or      dira , __x02sda

		jexit
		
\ this delay makes for a 384kHZ clock on an 80 Mhz prop   Xtal:5MHz
__x0Edelay/2
		mov     $C_treg6 , __x04delay/2
__x0D
		djnz    $C_treg6 , # __x0D                               
__x0Fdelayret
		ret
				
__x02sda
		h20000000
__x03scl
		h10000000
		
__x04delay/2
\ 384kHz
		hB
\ 100kHz
\          h30
          
;asm _eewrite
}


\ ------------------------------------------------------------------------------------------
\  Modified _eeread
\ ------------------------------------------------------------------------------------------
\ _eeread ( t/f -- c1 ) flag should be true is this is the last read
\ scl/sda use pull-up resistor at hi
\ clock:384kHz

{
build_BootOpt :rasm

		mov     $C_treg1 , $C_stTOS 
		mov     $C_stTOS , # 0
		andn    dira , __x02sda
		mov     $C_treg3 , # h8
		
__x0B
		jmpret  __x0Fdelayret , # __x0Edelay/2
          \ Set scl to Hi
          andn    dira , __x03scl          
		jmpret  __x0Fdelayret , # __x0Edelay/2

		test    __x02sda , ina	wc
		rcl     $C_stTOS , # 1

		jmpret  __x0Fdelayret , # __x0Edelay/2

          \ Set scl to 
          or      dira , __x03scl          
		jmpret  __x0Fdelayret , # __x0Edelay/2

		djnz    $C_treg3 , # __x0B
          jmpret  __x0Fdelayret , # __x0Edelay/2
          
		cmp     $C_treg1 , # 0 wz
		
		\ Set sda to hi if $C_treg is not 0
		muxz    dira , __x02sda
          
		jmpret  __x0Fdelayret , # __x0Edelay/2

          \ Set scl to Hi
          andn    dira , __x03scl
          
		jmpret  __x0Fdelayret , # __x0Edelay/2
		jmpret  __x0Fdelayret , # __x0Edelay/2

          \ Set scl to lo
	     or      dira , __x03scl
	     
	     \ Set sda to lo
          or      dira , __x02sda
          
		jmpret  __x0Fdelayret , # __x0Edelay/2

		jexit

\ this delay makes for a 384kHZ clock on an 80 Mhz prop   Xtal:5MHz
__x0Edelay/2
		mov     $C_treg6 , __x04delay/2
__x0D
		djnz    $C_treg6 , # __x0D
__x0Fdelayret
		ret

__x02sda
		h20000000
__x03scl
		h10000000
__x04delay/2
\ 384kHz
		hB

;asm _eeread
}






\ ------------------------------------------------------------------------------------------
\  Modified _eewrite with clockstretch
\ ------------------------------------------------------------------------------------------

{
\ Modified _eewrite_clockstretch ( c1 -- t/f ) write c1 to the eeprom, true if there was an error
\ Adding clockstretch at getting acknowledge
\ Received acknowledge from i2c-device during scl is high
\ clock:384kHz

build_BootOpt :rasm

		mov       $C_treg3 , # h8
          \ Set data-bit to sda
__x0B
		test	     $C_stTOS , # h80	wz
		muxz      dira , __x02sda
		jmpret	__x0Fdelayret , # __x0Edelay/2
                    		
          \ Set scl to Hi
          andn      dira , __x03scl
		jmpret	__x0Fdelayret , # __x0Edelay/2
		jmpret	__x0Fdelayret , # __x0Edelay/2

          \ Set scl to lo
          or        dira , __x03scl
		
		\ Shift data-bit
		shl       $C_stTOS , # 1

		jmpret	__x0Fdelayret , # __x0Edelay/2

          \ Finish 8bit?
		djnz      $C_treg3 , # __x0B

          \ Set sda to input(floating)
		andn      dira , __x02sda
		jmpret	__x0Fdelayret , # __x0Edelay/2

          \ Set scl to Hi
          andn      dira , __x03scl

		jmpret	__x0Fdelayret , # __x0Edelay/2
		
		\ check if scl is Hi  (clockstretch)
__1
		test    __x03scl , ina wz
if_z      jmp       __1     
		
		\ Input sda from slave   Read ACK
		test	     __x02sda , ina	wz
		muxnz     $C_stTOS , $C_fLongMask
		jmpret	__x0Fdelayret , # __x0Edelay/2

          \ Set scl to lo
          or        dira , __x03scl

		jmpret	__x0Fdelayret , # __x0Edelay/2
		jmpret	__x0Fdelayret , # __x0Edelay/2
		
		\ Set sda to lo and output
		or	dira , __x02sda

		jexit
		
\ this delay makes for a 384kHZ clock on an 80 Mhz prop   Xtal:5MHz
__x0Edelay/2
		mov	$C_treg6 , __x04delay/2
__x0D
		djnz	$C_treg6 , # __x0D                               
__x0Fdelayret
		ret
				
__x02sda
		h20000000                                               
__x03scl
		h10000000
		
__x04delay/2
\ 384kHz
		hB
          
;asm _eewrite
}
